;///////////////////////////////////////////////////////////////////////////////////////////////////
;/                               Fraction Simplification Program                                   /
;/                              Written by Donald Straney 10/13/03                                 /
;/                      Designed for the Z80/TI-86 graphing calculator                             /
;///////////////////////////////////////////////////////////////////////////////////////////////////

;///////////////////////////////////////DEFINITIONS/////////////////////////////////////////////////

#include "Ti86.inc"

.org _asm_exec_ram

    nop                                 ;Show shell title
    jp Prog_Start
    
    .dw 0,Shell_Title
    
Shell_Title: .db "Fraction Simplifier by Donald Straney",0

;/////////////////////////////////////////START OF PROGRAM//////////////////////////////////////////

Prog_Start:
    ld hl,_ioPrompt                     ;Clear IO prompt buffer
    ld (hl),$d7
    inc hl
    ld de,_ioPrompt+2
    ld (hl),0
    ld bc,9
    ldir
    call Get_Num                        ;Get the numerator
    call _op1toop6                      ;Move it to op3
    call Get_Num                        ;Get denominator
    call _op1toop2                      ;Move it to op2
    call _op6toop1                      ;Move the numerator to op1
    call _FPDIV                         ;Divide them
    call _tofrac                        ;convert to fraction
    push af                             ;Save flags register with carry flag
    ld hl,$3900                         ;Position small cursor at bottom of the screen
    ld (_penCol),hl
    ld hl,Shell_Title                   ;Display string to show that is in program
    call _vputs
    call _newline
    call _dispOP1                       ;Display the numerator of simplified fraction
    pop af                              ;Restore flags
    jr c,End_Prog                       ;If result is an integer (shown by carry flag set), then don't display denominator
    call _op2toop1                      ;Move denominator of simplified fraction to op1
    call _dispOP1                       ;Display it
End_Prog:
    jp _getkey                          ;Wait for keypress, then return

Get_Num:
    ld a,$0d                            ;Set to get value
    ld ($d623),a
    jp _exec_pg3                        ;Get the number

.end